//+------------------------------------------------------------------+
//|                                                        Genie.mq4 |
//|                                                   Genaro Gravoso |
//|                          http://www.oocities.org/ggravoso/b.html |
//+------------------------------------------------------------------+
#property copyright "Genaro Gravoso"
#property link      "http://www.oocities.org/ggravoso/b.html"
#property description "Relative Strength Index Stochastic expert advisor"
#property version   "1.00"
#property strict

#define MAGICMA  20140801
//--- Inputs
input double TakeProfit    =550;
input double Lots          =0.01;
input double MaximumRisk   =0.02;
input double DecreaseFactor=3;
input double StopLoss      =500;
extern bool trail = True;
extern double TrailingStop = 300;
extern double Lotss         =0.01;
extern double LotDigits     =2;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//--- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//--- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//--- return lot size
   if(lot<0.01) lot=0.01;
   return(lot);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double S150,S4A,S4B,S4C,S21,S4D,S21B,S21C,S21D,S150D,S150C,S150B,S150E,S150F,S150J,S4E,S21E,S21F;
   int    res;
//--- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//--- to simplify the coding and speed up access data are put into internal variables
   S150=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,0);
   S150B=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,1);
   S150C=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,2);
   S150D=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,3);
   S150E=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,4);
   S150F=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,5);
   S150J=iStochastic(NULL,0,48,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,9);
   S4A=iStochastic(NULL,0,4,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,0);
   S4B=iStochastic(NULL,0,4,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,1);
   S4C=iStochastic(NULL,0,4,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,2);
   S4D=iStochastic(NULL,0,4,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,3);
   S4E=iStochastic(NULL,0,4,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,4);
   S21=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,0);
   S21B=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,1);
   S21C=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,2);
   S21D=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,3);
   S21E=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,4);   
   S21F=iStochastic(NULL,0,18,1,1,MODE_SMA,STO_LOWHIGH,MODE_SIGNAL,5);
     //--- sell conditions TWO 
   if(S150<30)
   if(S4A<20)
   if(S4D>40)
   if(S150J>55)
   if(S150J<65)
     {
      res=OrderSend(Symbol(),OP_SELL,NormalizeDouble(Lotss,LotDigits),Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"Genie",MAGICMA,0,Red);
      return;
     }
//--- buy conditions TWO 
   if(S150>70)
   if(S4A>80)
   if(S4D<60)
   if(S150J<45)
   if(S150J>35)
     {
      res=OrderSend(Symbol(),OP_BUY,NormalizeDouble(Lotss,LotDigits),Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"Genie",MAGICMA,0,Blue);
      return;
     }

  }
//place before init, or after the code at the bottom
void trail() 
{
for (int i = 0; i < OrdersTotal(); i++) {
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

if ( OrderSymbol()==Symbol() ) 
{
if (OrderType() == OP_BUY) {
if (Bid - OrderOpenPrice() > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
if (OrderStopLoss() < Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
}
}
} else if (OrderType() == OP_SELL) {
if (OrderOpenPrice() - Ask > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
if ((OrderStopLoss() > Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) || 
(OrderStopLoss() == 0)) {
OrderModify(OrderTicket(), OrderOpenPrice(),
Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red); 
}
}
}
}
}
}

  
//+------------------------------------------------------------------+
//| OnTick function                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false)
      return;
//--- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
//---
  }
//+------------------------------------------------------------------+